/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.usergrid.management;


import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;


@Entity
@Table(name = "Organizations")
public class OrganizationProfile {

    @Id
    private String name;

    @Column(name = "email")
    private String email;

    // some stuff to collect

    @Column(name = "contact")
    private String contact;

    @Column(name = "paypal")
    private String paypal;


    public OrganizationProfile() {

    }


    public String getName() {
        return name;
    }


    public void setName( String name ) {
        this.name = name;
    }


    public String getEmail() {
        return email;
    }


    public void setEmail( String email ) {
        this.email = email;
    }


    public String getContact() {
        return contact;
    }


    public void setContact( String contact ) {
        this.contact = contact;
    }


    public String getPaypal() {
        return paypal;
    }


    public void setPaypal( String paypal ) {
        this.paypal = paypal;
    }
}
